<?php
namespace nulib\db\pdo;

use nulib\db\_private\_base;
use nulib\db\_private\_create;
use nulib\db\_private\_delete;
use nulib\db\_private\_generic;
use nulib\db\_private\_insert;
use nulib\db\_private\_select;
use nulib\db\_private\_update;
use nulib\db\_private\Tbindings;
use nulib\ValueException;

class query extends _base {
  use Tbindings;

  protected static function verifix(&$sql, ?array &$bindings=null, ?array &$meta=null): void {
    if (is_array($sql)) {
      $prefix = $sql[0] ?? null;
      if ($prefix === null) {
        throw new ValueException("requête invalide");
      } elseif (_create::isa($prefix)) {
        $sql = _create::parse($sql, $bindings);
        $meta = ["isa" => "create", "type" => "ddl"];
      } elseif (_select::isa($prefix)) {
        $sql = _select::parse($sql, $bindings);
        $meta = ["isa" => "select", "type" => "dql"];
      } elseif (_insert::isa($prefix)) {
        $sql = _insert::parse($sql, $bindings);
        $meta = ["isa" => "insert", "type" => "dml"];
      } elseif (_update::isa($prefix)) {
        $sql = _update::parse($sql, $bindings);
        $meta = ["isa" => "update", "type" => "dml"];
      } elseif (_delete::isa($prefix)) {
        $sql = _delete::parse($sql, $bindings);
        $meta = ["isa" => "delete", "type" => "dml"];
      } elseif (_generic::isa($prefix)) {
        $sql = _generic::parse($sql, $bindings);
        $meta = ["isa" => "generic", "type" => null];
      } else {
        throw ValueException::invalid_kind($sql, "query");
      }
    } else {
      if (!is_string($sql)) $sql = strval($sql);
      if (_create::isa($sql)) {
        $meta = ["isa" => "create", "type" => "ddl"];
      } elseif (_select::isa($sql)) {
        $meta = ["isa" => "select", "type" => "dql"];
      } elseif (_insert::isa($sql)) {
        $meta = ["isa" => "insert", "type" => "dml"];
      } elseif (_update::isa($sql)) {
        $meta = ["isa" => "update", "type" => "dml"];
      } elseif (_delete::isa($sql)) {
        $meta = ["isa" => "delete", "type" => "dml"];
      } elseif (_generic::isa($sql)) {
        $meta = ["isa" => "generic", "type" => null];
      } else {
        $meta = ["isa" => "generic", "type" => null];
      }
    }
  }

  const DEBUG_QUERIES = false;

  function useStmt(\PDO $db, ?\PDOStatement &$stmt=null, ?string &$sql=null): bool {
    if (static::DEBUG_QUERIES) { #XXX
      error_log($this->sql);
      //error_log(var_export($this->bindings, true));
    }
    if ($this->bindings !== null) {
      $stmt = $db->prepare($this->sql);
      foreach ($this->bindings as $name => $value) {
        $this->verifixBindings($value);
        $stmt->bindValue($name, $value);
      }
      return true;
    } else {
      $sql = $this->sql;
      return false;
    }
  }
}
